local PATH = "nametags.cfg"
local modname = "NameTags"

local commands = {
	{"nametag On", "Toggles nametags on/off"}, 
	{"nt_charlimit 10", "Limits the amount of characters in names"}, 
	{"nt_clan On", "Display the player's clan next to the name"},
	{"nt_skinicon Off", "Display the Skin icon the player is using next to the name"}, 
	{"nt_skinstats Restat", "Display the player's stats above their name {Off, Restat, Always}"}, 
	{"nt_maxdist 160", "Changes the maximum distance the nametag can reach"},
	{"nt_cap 4", "Change how many nametag can appear on your screen"},
	{"nt_smalltag Off", "Make nametag's size smaller"},
	{"nt_posadjust 0", "Adjust nametag position, maybe you need it (incase of custom fov/resolution)"},
	{"nt_hudtrans Dynamic", "Change how nametag manage the hud's transparent {Fix, Dynamic}"}
}

local function loadconfig()
	if replayplayback then return end
	if not (consoleplayer) or (consoleplayer.nametag_autoloaded) then return end
	
	local file = io.open(PATH, "r")
	if not file then
		file = io.open(PATH, "w")
		if not file then
			CONS_Printf(consoleplayer, "A "..modname.." config couldn't be generated. Write permission issues?")
		end
		CONS_Printf(consoleplayer, "\130A "..modname.." config was created in luafiles/"..PATH..".")
		CONS_Printf(consoleplayer, "\130Commands placed there will run when you join the "..modname..".")
		-- write all our defaults to it.
		for i = 1, #commands
			local command = commands[i][1]
			local command_desc = commands[i][2]
			
			file:write(command.." // "..command_desc.."\n")
		end
	else
		CONS_Printf(consoleplayer, "\130A "..modname.." config is found. Loading, sit tight...")
		local buf = file:read()
		while buf
			COM_BufInsertText(consoleplayer, buf)
			buf = file:read()
		end
	end
	file:close()
	consoleplayer.nametag_autoloaded = true
end

addHook("ThinkFrame", loadconfig)
addHook("IntermissionThinker", loadconfig)
addHook("VoteThinker", loadconfig)